let cenX = -1.4999;
let cenY = 0.0;
let disScale = 1;

function drawBrot(ctx) {
    for (let x = 0; x < xr; x+=2) {
        for (let y = 0; y < yr; y+=2) {
            let c = pixelToPoint(x, y);
            let result = calculatePoint(c);
            if (result.isIn) {                
                setPixel(x, y, 0, 0, 0, 255);
            }
            else if (result.i > 1) {
                setPixel(x, y,
                    150 + 200 - Math.pow(result.i/(50), 0.5) * 200 % 255, 80, 100, 255);
                    //result.i % 255, 80, 150, 255);
            }
            else {
                setPixel(x, y, 50, 50, 50, 255);
            }
        }
    }
    ctx.putImageData(myImageData, 0, 0);

}

function setPixel(x, y, r, g, b, a) {
    myImageData.data[4 * (y * myImageData.width + x)]     = r;
    myImageData.data[4 * (y * myImageData.width + x) + 1] = g;
    myImageData.data[4 * (y * myImageData.width + x) + 2] = b;
    myImageData.data[4 * (y * myImageData.width + x) + 3] = a;
}


function pixelToPoint(x, y) {
    let p = {
        x: (x - xr / 2) * ( 4 / xr) * screenRatio / disScale + cenX,
        y: (y - yr / 2) * (4 / yr) * (1 / disScale) + cenY
    }
    return p;
}

function calculatePoint(c) {
    let z0 = {x: 0, y: 0};
    let i = 0;
    let boundsSquare = 2 * 2;
    let isIn = true;

    let depthCheck = 700;

    while (i < depthCheck && isIn) {
        z1 = {
            x: z0.x * z0.x - z0.y * z0.y + c.x,
            y: 2 * z0.x * z0.y + c.y
        };
        z0 = z1;
        i++;
        if (magnitudeSquare(z0) > boundsSquare) {
            isIn = false;
        }
    }

    return {
        'i': i,
        'isIn': isIn
    };

}

function magnitudeSquare(c) {
    return c.x * c.x + c.y * c.y;
}

function updateDemo(s) {

    //cenX -= 0.01 * 1 / disScale;
    disScale +=  disScale * 0.01;
    //console.log(disScale);

    

}

function drawDemo(ctx, s) {
    drawBrot(ctx);
}

function centerText(ctx, txt, y) {
    ctx.beginPath();
    ctx.fillText(txt, (xr - ctx.measureText(txt).width) / 2, y);
    ctx.closePath();
}

function drawCircle(ctx, x, y, r) {
    ctx.arc(x, y, r, 0, Math.PI * 2);
}